#ifndef __CONNECTION_H
#define __CONNECTION_H

#include <iostream>
#include "packet.h"

class PackList
{
public:
	PackList (Packet * m_val, PackList * m_next)
	{
		if (DEBUG)
			assert (m_val != NULL);
		val = m_val; next = m_next;
	}
	~PackList ()
	{
		delete val;
		if (next != NULL)
			delete next;
	}
	Packet * getVal()
	{ return val; }

	PackList * next;
private:
	Packet * val;
};

class Connection
{
public:
	/* constructs a connection, makes a copy of
	 * the packet as 'refpacket', and adds the
	 * packet to the packlist */
	Connection (Packet * packet);

	~Connection();

	/* add a packet to the packlist 
	 * will delete the packet when it is
	 * 'merged' with another packet
	 */
	void add (Packet * packet);

	int getLastPacket ()
	{ return lastpacket; }

	/* sums up the total bytes used,
	 * and removing 'old' packets. */
	bpf_u_int32 sumanddel (timeval curtime);

	/* for checking if a packet is part of this connection */
	Packet * refpacket;
private:
	PackList * packets; 
	int lastpacket;
};

/* Find the connection this packet belongs to */
Connection * findConnection (Packet * packet);

#endif
